var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __slice = Array.prototype.slice;
({
  _traverse: function(accum, _arg) {
    var handleNotFound, i, len, next, obj, parent, path, prop, props, _results;
    path = _arg.path, obj = _arg.obj, handleNotFound = _arg.handleNotFound;
    props = path.split('.');
    len = props.length;
    i = 0;
    next = obj;
    _results = [];
    while (i < len) {
      prop = props[i++];
      parent = next;
      next = parent[prop];
      _results.push(next === void 0 ? handleNotFound(path, obj) : void 0);
    }
    return _results;
  },
  traverse: function(path, obj, callback) {
    var curr, halt, i, isLast, len, newCurr, newParent, newProp, parent, prefix, prop, props;
    curr = obj || this._data;
    props = path.split('.');
    prefix = '';
    i = 0;
    len = props.length;
    while (i < len) {
      parent = curr;
      prop = props[i++];
      curr = parent[prop];
      isLast = i === len;
      if (obj = callback(curr, prefix, prop, parent, isLast)) {
        newCurr = obj.newCurr, newProp = obj.newProp, newParent = obj.newParent, halt = obj.halt;
        if (newCurr) {
          curr = newCurr;
        }
        if (newProp) {
          prop = newProp;
        }
        if (newParent) {
          parent = newParent;
        }
      }
      if (halt) {
        return {
          val: curr,
          prefix: prefix,
          prop: prop,
          parent: parent
        };
      }
    }
    return {
      val: curr,
      prefix: prefix,
      prop: prop,
      path: path,
      parent: parent
    };
  },
  denormalizePath: function(path, obj) {
    var val, _ref;
    _ref = this.traverse(path, obj, function(curr, prefix, prop, parent, isLast) {
      if (curr === void 0) {
        return {
          halt: true
        };
      }
    }), val = _ref.val, path = _ref.path;
    if (val === void 0) {
      return path;
    }
    return path;
  },
  lookup: function(path, addPath, options) {
    var array, dontFollowLastRef, parent, prefix, prop, proto, val, _ref;
    proto = options.proto, array = options.array, dontFollowLastRef = options.dontFollowLastRef;
    _ref = this.traverse(path, options.obj, __bind(function(curr, prefix, prop, parent, isLast) {
      var key, keyVal, ref;
      if (proto && !specHelper.isSpeculative(parent)) {
        parent = specHelper.create(parent);
      }
      if (curr === void 0) {
        if (!addPath) {
          return {
            halt: true,
            curr: curr
          };
        }
        if (array && isLast) {
          curr = proto ? specHelper.create([]) : [];
        } else {
          curr = proto ? specHelper.create({}) : {};
        }
        parent[prop] = curr;
      } else if (proto && typeof curr === 'object' && !specHelper.isSpeculative(curr)) {
        if (specHelper.isSpeculative(parent && parent.hasOwnProperty(prop))) {
          curr._proto = true;
        } else {
          curr = specHelper.create(curr);
        }
        parent[prop] = curr;
      }
      if (ref = curr.$r) {
        if (isLast && dontFollowLastRef) {
          return {
            curr: curr,
            prefix: prefix,
            prop: prop,
            parent: parent
          };
        }
        if (!(key = curr.$k)) {
          curr = this.lookup(ref, addPath, options).obj;
        } else {
          keyVal = this.lookup(key, false, options).obj;
          if (specHelper.isArray(keyVal)) {
            curr = keyVal.map(__bind(function(key) {
              return this.lookup(ref + '.' + key, false, options).obj;
            }, this));
          }
        }
      }
      return {
        parent: parent,
        curr: curr
      };
    }, this)), val = _ref.val, prefix = _ref.prefix, prop = _ref.prop, parent = _ref.parent;
    return {
      obj: val,
      prop: prop,
      path: path,
      parent: parent
    };
  },
  _addTxn: function() {
    var args, callback, id, method, path, txn, ver, _i;
    method = arguments[0], args = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), callback = arguments[_i++];
    id = this._nextTxnId();
    ver = this._force ? null : this._adapter.ver;
    txn = [ver, id, method].concat(__slice.call(args));
    txn = this._refHelper.dereferenceTxn(txn);
    args[0] = path = txn[3];
    txn.callback = callback;
    this._txns[id] = txn;
    this._txnQueue.push(id);
    if (pathParser.isPrivate(path)) {
      return this._applyTxn(txn);
    }
    this.emit(method, args);
    return this._commit(txn);
  }
});